//Pass The Pie - (C) 2012 Cafeinoz. All rights reserved.
//valac --pkg gtk+-3.0 --pkg gmodule-2.0 ptp.vala ui.vala ptp.c

using Gtk;

extern int main_cli(int argc, char** argv);
extern int addseed(char* seed);
extern char* genseed();
extern char* pass(char* password, char* website);
extern int amhohwa(char* filee, char* password);

int about(string[] args)
{
	try {
		Gtk.init (ref args);
		var builder = new Builder ();
		builder.add_from_string (aboutui, -1);
		builder.connect_signals (null);
		var window = builder.get_object ("about_window") as AboutDialog;
		window.response.connect(() => {
			window.destroy();
		});
		window.destroy.connect(Gtk.main_quit);
		window.show_all ();
		Gtk.main ();
	} catch (Error e) {}
	return 0;
}

int seed(string[] args)
{
	try {
		Gtk.init (ref args);
		var builder = new Builder ();
		builder.add_from_string (seedui, -1);
		builder.connect_signals (null);
		var window = builder.get_object ("seed_window") as Window;
		var seed_box = builder.get_object ("seed_box") as TextView;
		var quit_button = builder.get_object ("quit_button") as Button;
		var export_button = builder.get_object ("export_button") as Button;
		var seed_button = builder.get_object ("seed_button") as Button;
		try {
			string text;
			FileUtils.get_contents (GLib.Environment.get_variable("HOME") + "/.PTPie", out text);
			seed_box.buffer.text = text;
		} catch (Error e) {
			stderr.printf ("Error: %s\n", e.message);
		}
		quit_button.clicked.connect(() => {
			addseed((char *) seed_box.buffer.text);
			window.destroy();
		});
		seed_button.clicked.connect(() => {
			seed_box.buffer.text = (string) genseed();
		});
		export_button.clicked.connect(() => {
			var file_chooser = new FileChooserDialog ("Save File", window,
				FileChooserAction.SAVE,
				Stock.CANCEL, ResponseType.CANCEL,
				Stock.OPEN, ResponseType.ACCEPT);
			if (file_chooser.run () == ResponseType.ACCEPT) {
				try {
				    FileUtils.set_contents(file_chooser.get_filename (), seed_box.buffer.text);
				} catch (Error e) {
				    stderr.printf ("Error: %s\n", e.message);
				}
			}
			file_chooser.destroy ();
		});
		window.destroy.connect(Gtk.main_quit);
		window.show_all ();
		Gtk.main ();
	} catch (Error e) {}
	return 0;
}

int main(string[] args) {   
	if (args.length > 2 || args[1] == "sgen")
	{
		main_cli(args.length, (char**) args);
		return 0;
	}
	if (args.length == 2)
	{
		Gtk.init (ref args);
		var window = new Window ();
		window.title = "Decrypt";
		window.border_width = 10;
		window.set_default_size (300, 20);
		window.destroy.connect (Gtk.main_quit);
		var pass_entry = new Entry ();
		pass_entry.placeholder_text = "Password";
		pass_entry.set_visibility(false);
		var web_entry = new Entry ();
		web_entry.placeholder_text = "Website";
		var vbox = new Box (Orientation.VERTICAL, 10);
		window.add (vbox);
		vbox.add (pass_entry);
		vbox.add (web_entry);
		window.show_all ();
		web_entry.activate.connect (() => {
			amhohwa((char*) args[1], pass((char*) pass_entry.text, (char*) web_entry.text));
			window.destroy();
		});
		pass_entry.activate.connect (() => {
			amhohwa((char*) args[1], pass((char*) pass_entry.text, (char*) web_entry.text));
			window.destroy();
		});
		Gtk.main ();
		return 0;
	}
	Gtk.init (ref args);
	try {
		var builder = new Builder ();
		builder.add_from_string (ptpui, -1);
		builder.connect_signals (null);
		var window = builder.get_object ("main_window") as Window;
		var quit_button = builder.get_object ("quit_button") as Button;
		var generate_button = builder.get_object ("generate_button") as Button;
		var copy_button = builder.get_object ("copy_button") as Button;
		var key_text = builder.get_object ("key_text") as TextView;
		var pass_entry = builder.get_object ("pass_entry") as Entry;
		var web_entry = builder.get_object ("web_entry") as Entry;
		var menu_quit = builder.get_object ("menu_quit") as ImageMenuItem;
		var menu_about = builder.get_object ("menu_about") as ImageMenuItem;
		var menu_seed = builder.get_object ("menu_seed") as ImageMenuItem;
		var menu_crypt = builder.get_object ("menu_crypt") as ImageMenuItem;
		generate_button.clicked.connect (() => {
			if (web_entry.text != "" && pass_entry.text != "")
				key_text.buffer.text = (string) pass((char*) pass_entry.text, (char*) web_entry.text);
		});
		copy_button.clicked.connect (() => {
			key_text.select_all(true);
			key_text.copy_clipboard();
		});
		menu_about.activate.connect(() => {
			about(args);
		});
		menu_seed.activate.connect(() => {
			seed(args);
		});
		menu_crypt.activate.connect(() => {
			if (key_text.buffer.text == "")
			{
				var dialog = new MessageDialog (window,
					Gtk.DialogFlags.DESTROY_WITH_PARENT,
					MessageType.ERROR, 						ButtonsType.OK,
					"Key must be generated");
				dialog.response.connect (() => {
					dialog.destroy();
				});
 				dialog.show ();
			} else {
				var file_chooser = new FileChooserDialog ("Open File", window,
					FileChooserAction.OPEN,
					Stock.CANCEL, ResponseType.CANCEL,
					Stock.OPEN, ResponseType.ACCEPT);
				if (file_chooser.run () == ResponseType.ACCEPT) {
					amhohwa((char*) file_chooser.get_filename (), (char*) key_text.buffer.text);
				}
				file_chooser.destroy ();
			}
		});
		menu_quit.activate.connect(Gtk.main_quit);
		quit_button.clicked.connect(Gtk.main_quit);
		window.destroy.connect(Gtk.main_quit);
		window.show_all ();
		Gtk.main ();
	} catch (Error e) {
		stderr.printf ("Could not load UI: %s\n", e.message);
		return 1;
	} 
	return 0;
}
