//Pass The Pie - (C) 2012 Cafeinoz. All rights reserved.
//gcc ptp.c -D __CLI__
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#ifdef __WIN32__
	char* DATASTORE = "APPDATA";
#else
	#ifdef __ANDROID_API__
		char* DATASTORE = "EXTERNAL_STORAGE";
	#else
		char* DATASTORE = "HOME";
	#endif
#endif

unsigned int randgen(unsigned int start, char key[1000])
{
	char cal[4] = {key[start % 997], key[start % 997 + 1], key[start % 997 + 2], '\0'};
	return ((atoi(cal) * start) << (atoi(cal) % 32)) + ((atoi(cal) + start) % 2);
}

int addseed(char* seed)
{
	char fileloc[50];
	sprintf(fileloc, "%s/%s", getenv(DATASTORE), ".PTPie");
	FILE* keyfile = fopen(fileloc, "w");
	fputs(seed, keyfile);
	fclose(keyfile);
	return 0;
}

char* genseed()
{
	static char key[1000];
	int count;
	for (count = 0; count < 1000; count++)
	{
		srand(rand() * time(NULL));
		key[count] = rand() % 10 + 48;
	}
	key[1000] = 0;
	addseed(key);
	return key;
}

void genmod(char* password, unsigned int* num, unsigned int* add)
{
	unsigned int count_x;
	int rea = 1, rev = 1;
	for (count_x = 0; password[count_x] != 0; count_x++)
	{
		if (((*num + password[count_x] * (count_x + 1)) * (rev * 2 - 1) > 4294967295u) | ((*num + password[count_x] * (count_x + 1)) * (rev * 2 - 1) < 0))
			rev = 0 - rev;
		*num += (password[count_x] * (count_x + 1)) * rev;
		if (((*add + password[count_x] - 97) * rea > 4294967295u) | ((*add + password[count_x] - 97) * rea < 1))
			rea = - rea;
		*add += (*add + password[count_x] - 97) * rea;
	}
}

void loadkey(char* key)
{
	char fileloc[100];
	sprintf(fileloc, "%s/%s", getenv(DATASTORE), ".PTPie");
	FILE* keyfile;
	if((keyfile = fopen(fileloc, "r")))
	{
		fgets(key, 1000, keyfile);
		fclose(keyfile);
	}
}

int amhohwa(char* filee, char* password)
{
	unsigned int add = 0, num = 0, size, ran;
	int rev = 1, rea = 1, reverse = 1;
	genmod(password, &num, &add);
	FILE* ifile;
	if((ifile = fopen(filee, "r")))
	{} else {
		printf("File not found.\n");
		return 1;
	}
	char outputf[100];
	sprintf(outputf, "%s\0", filee);
	int outlen = 0;
	while (outputf[outlen] != '\0')
		outlen++;
	if (filee[outlen-4] == '.' && filee[outlen-3] == 'a' && filee[outlen-2] == 'h' && filee[outlen-1] == 'h')
		outputf[outlen-4] = '\0';
	else
		sprintf(outputf, "%s%s", filee, ".ahh");
	FILE* ofile = fopen(outputf, "w");
	unsigned char buffer[1], revtest[4];
	size = fread(revtest, 1, 4, ifile);
	if (revtest[0] == 'A' && revtest[1] == '3' && revtest[2] == 'H' && revtest[3] == 'S')
		reverse = -1;
	else
	{
		rewind(ifile);
		fwrite("A3HS", 1, size, ofile);
	}
	char key[1000];
	loadkey(key);
	while (!feof(ifile))
	{
		ran = randgen(num, key) % 32;
		if (((num + (add << ran)) > 4294967295u) | (num + (add << ran)) < 0)
			rev = 0 - rev;
		num += (add << ran) * rev;
		size = fread(buffer, 1, 1, ifile);
		rea = 1;
		if (((unsigned int) buffer[0] + (num * reverse * rea) > 4294967295u) | ((unsigned int) buffer[0] + (num * reverse * rea) < 0))
			rea = 0 - rea;
		buffer[0] += num * rea * reverse;
		fwrite(buffer, 1, size, ofile);
	}
	fclose(ofile);
	fclose(ifile);
	return 0;
}

char* pass(char* password, char* website)
{
	char grid[26][26], key[1000];
	loadkey(key);
	unsigned int count_y, count_x, add = 0, num = 0;
	int rev = 1;
	genmod(password, &num, &add);
	for (count_y = 0 ; count_y <= 25 ; count_y++)
	{
		for (count_x = 0 ; count_x <= 25 ; count_x++)
		{
			switch (randgen(num, key) % 3)
			{
				case 0:
					grid[count_y][count_x] = (char) (randgen(num, key) % 10 + 48);
				break;
				case 1:
					grid[count_y][count_x] = (char) (randgen(num, key) % 26 + 65);
				break;
				case 2:
					grid[count_y][count_x] = (char) (randgen(num, key) % 26 + 97);
				break;
			}
			if (((num + add) * rev > 4294967295u) | ((num + add) * rev < 0))
				rev = 0 - rev;
			num += add * rev;
		}
	}
	if ((website[0] == 'g') & (website[1] == 'r') & (website[2] == 'i') & (website[3] == 'd') & (website[4] == 0))
	{
		static char output[1460];
		char* temp = output;
		temp += sprintf(temp, "/\ta b c d e f g h i j k l m n o p q r s t u v w x y z\n\n");
		for (count_y = 0; count_y <= 25; count_y++)
		{
			temp += sprintf(temp, "%i\t", count_y + 1);
			for (count_x = 0; count_x <= 25; count_x++)
				temp += sprintf(temp, "%c ", grid[count_y][count_x]);
			if (count_y < 25)
				temp += sprintf(temp, "\n");
		}
		return output;
	} else {
		static char output[26];
		count_y = 0;
		for (count_x = 0; count_x <= 25; count_x++)
		{
			if (website[count_y] == 0)
				count_y = 0;
			else if (website[count_y] > 64 && website[count_y] < 91)
				website[count_y] += 32;
			else if (website[count_y] > 47 && website[count_y] < 58)
				website[count_y] += 64;
			else if (website[count_y] < 97 || website[count_y] > 122)
				website[count_y] = 's';
			output[count_x] = grid[count_x][website[count_y] - 97];
			count_y++;
		}
		output[26] = '\0';
		return output;
	}
}

#ifdef __CLI__
int main(int argc, char **argv)
#else
int main_cli(int argc, char **argv)
#endif
{
	if ((argc == 2) && (argv[1][0] == 's') & (argv[1][1] == 'g') & (argv[1][2] == 'e') & (argv[1][3] == 'n') & (argv[1][4] == 0))
		printf("%s\n", genseed());
	else if (argc == 4)
		amhohwa(argv[3], pass(argv[1], argv[2]));
	else if (argc != 3)
	{
		printf("Usage: %s [password] [site]\nLETTERS ONLY IN SITE!!!\n" \
			"Use \"grid\" as site to view the grid\n" \
			"Use \"sgen\" as password before first run or\n" \
			"use \"sadd\" to add your own key\n", argv[0]);
		return 1;
	} else if ((argv[1][0] == 's') & (argv[1][1] == 'a') & (argv[1][2] == 'd') & (argv[1][3] == 'd') & (argv[1][4] == 0))
		addseed(argv[2]);
	else
		printf("%s\n", pass(argv[1], argv[2]));
	return 0;
}
